<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: error.inc
'
'	Modification History:
'	
'	Date		Who			What
'	6/24/99		PSun		Added modification history.
'	8/18/99		PSun		Added SessionID to window name.
'

' Encapsulate the passed in message in the rows of a surrounding
' table that emulates an error dialog box.
'
Sub WriteEDTmsg (dlgmsg)
	On Error Resume Next
	If IsArray(dlgmsg) Then
		Dim ix
		For ix=LBound(dlgmsg) To UBound (dlgmsg)
			Response.Write	vbTab+"<tr>"+vbCrLf+_
							vbTab+vbTab+"<td bgcolor='#c0c0c0' align='left'>"+vbCrLf+_
							vbTab+vbTab+vbTab+Replace(dlgmsg(ix), ""+CHR(34)+"", "&quot;")+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf+_
							vbTab+"</tr>"+VbCrLf
		Next
	Else
		Response.Write	vbTab+"<tr>"+vbCrLf+_
						vbTab+vbTab+"<td bgcolor='#c0c0c0' align='left'>"+vbCrLf+_
						vbTab+vbTab+vbTab+Replace(dlgmsg, ""+CHR(34)+"", "&quot;")+vbCrLf+_
						vbTab+vbTab+"</td>"+vbCrLf+_
						vbTab+"</tr>"+VbCrLf
	End If
End Sub


Sub WriteButtonDialog (dlgtype, dlgmsg, button_name, button_label, _
							button_script)
	On Error Resume Next
	trace "WriteButtonTable "
	Response.Write 	"<table border='0' width='100%'>"+vbCrLf
	WriteEDTmsg dlgmsg
	Response.Write 	vbTab+"<tr>"+vbCrLf+_
					vbTab+vbTab+"<td bgcolor='#c0c0c0' align='center'>"+vbCrLf+_
					vbTab+vbTab+"<br><input type='Submit'"
	If button_name <> "" Then
		Response.Write " name='"+button_name+"'"
	End If
	If button_label <> "" Then
		Response.Write " value='"+button_label+"'"
	End If
	If button_script <> "" Then
		Response.Write " onClick='"+button_script+"'"
	End If
	Response.Write	" style='font-family: Arial; font-size: 9pt'"
	Response.Write	">"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+"</tr>"+vbCrLf+_
					vbTab+"</table>"+vbCrLf
	
End Sub


Sub ErrorDialog (dlgtype, button)
	Session("Error") = Err.Description
	Session("DlgType") = dlgtype
	Session("Button") = button
	call ClearError
	%>
		<script language='JavaScript'> 
			var iScreenW = screen.width;
			var iScreenH = screen.height;
			var winChild;
	
			if (window.navigator.appName == 'Netscape') {
				iScreenW = window.outerWidth/2 + window.screenX - 150;
				iScreenH = window.outerHeight/2 + window.screenY - 50;
			}
			
			winChild = window.open('','ErrorDialog<%=Session("SessionID")%>','width=300,height=100,resizable=yes,left='
									+iScreenW+',top='+iScreenH+
									',screenX='+iScreenW+',screenY='+iScreenH);
			self.focus();
			winChild.location.replace('error_dialog.asp');
			if (window.opener == null) {
				top.winError = winChild;
			} else {
				window.opener.top.winError = winChild;
			}
		</script>
	<%
End Sub

'
' Function Error(msg)
'
' Description:
'	Display an error message if an error occured.
' Method:
'	If an error occured it will:
'		1) Dump the error (if a non-empty message was provided) 
'			to the Tracer (along with error details)
'		2) Clear the error object
' Returns:
'	True - If an error occurred
'	False - If no error occurred.
'
function Error (msg)
	If CheckError Then
		Call DumpError(msg)
		Call ClearError
		Error = True
	Else
		Error = False
	End If
End Function

'
' Function CheckError()
'
' Description:
'	Simply returns whether an error occured or not
' Method:
' Arguments:
'	msg - Text message to send to Tracing utility
' Returns:
'	True - If an error occurred
'	False - If no error occurred.
'
Function CheckError 
	If Err.Description <> "" Then
		CheckError = True
	Else
		CheckError = False
	End If
End Function


'
' Subroutine ClearError()
'
' Description:
'	Clears the Err object
'
Sub ClearError
	Err.Clear
End Sub

%>




