<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: misc.inc
'
'	Modification History:
'	
'	Date		Who			What
'	8/13/99		PSun		Modification History Added. 
'	8/18/99		PSun		Added SessionID to frame names

Dim Misc_Inc_DbgTraceToStrEnabled,_
	Misc_Inc_dbgTraceStr,_
	Misc_Inc_dbgTraceEnabled,_
	Misc_Inc_biObj

Misc_Inc_dbgTraceEnabled = False
Misc_Inc_DbgTraceToStrEnabled = False

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function BrowserIsMSIE()
	On Error Resume Next
	BrowserIsMSIE = False
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "BrowserIsMSIE Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	BrowserIsMSIE = (Misc_Inc_biObj.bType = "MSIE")
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function BrowserIsNetscape()
	On Error Resume Next
	BrowserIsNetscape = False
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "BrowserIsNetscape Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	BrowserIsNetscape = (Misc_Inc_biObj.bType = "NetScape")
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function BrowserIs16Bit()
	On Error Resume Next
	BrowserIs16Bit = False
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "BrowserIs16Bit Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	BrowserIs16Bit = Misc_Inc_biObj.is16Bit
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetBrowserType()
	On Error Resume Next
	GetBrowserType = ""
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "GetBrowserType Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	GetBrowserType = Misc_Inc_biObj.bType
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetBrowserVersion()
	On Error Resume Next
	GetBrowserVersion = ""
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "GetBrowserVersion Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	GetBrowserVersion = CStr(Misc_Inc_biObj.majorVersion) &_
					  "."&CStr(Misc_Inc_biObj.minorVersion)
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetBrowserMajorVersion()
	On Error Resume Next
	GetBrowserMajorVersion = ""
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "GetBrowserMajorVersion Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	GetBrowserMajorVersion = Misc_Inc_biObj.majorVersion
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function GetBrowserMinorVersion()
	On Error Resume Next
	GetBrowserMinorVersion = ""
	If Not IsValidObject (Misc_Inc_biObj) Then
		Set Misc_Inc_biObj = CreateBrowserInfoObj()
		If Not IsvalidObject (Misc_Inc_BiObj) Then
			FaultTrace "GetBrowserMinorVersion Couldn't Create Valid "&_
					   "BrowserinfoObj "&Err.Description
			Err.clear
			Exit Function
		End If
	End If
	GetBrowserMinorVersion = Misc_Inc_biObj.minorVersion
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Write out the JavaScript chkform function
'
Sub WriteChkFormJSfunc(chkformflag)
	On Error Resume Next
	BeginJavaScript
	Response.Write _
			"var "&chkformflag&" = false;"&vbCrLf&_
			"function chkform (flag)"&VbCrLf&_
			"{"&vbCrLf&_
			"	if (! flag && ! "&chkformflag&") { return false; }"&VbCrLf&_
			"	if (flag) {"&vbCrLf&_
			"		"&chkformflag&" = true;"&VbCrLf&_
			"	} else {"&VbCrLf&_
			"		"&chkformflag&"=false;"&vbCrLf&_
			"	}"&vbCrLf&_
			"	return true;"&vbCrLf&_
			"}"&VbCrLf
	EndJavaScript
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' returns the value of the dbgTraceStr dimmed in this include file
' 
Function DbgTraceStrValue
	DbgTraceStrValue = Misc_Inc_dbgTraceStr
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Enable Debug Tracing - by default turned off
'
Function DbgEnableTrace(enable_boolean)
	DbgEnableTrace = Misc_Inc_dbgTraceEnabled
	Misc_Inc_dbgTraceEnabled = enable_boolean
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Enable Tracing to strings - you can get the accumulated trace
' output by calling the dbgTraceStr function
'
Function DbgEnableTraceToStr (enable_boolean)
	DbgEnableTraceToStr = Misc_Inc_DbgTraceToStrEnabled
	Misc_Inc_DbgTraceToStrEnabled = enable_boolean
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Tells us if Dbg Tracing to string is enabled or not
'
Function DbgTraceToStrEnabled
	DbgTraceToStrEnabled = Misc_Inc_DbgTraceToStrEnabled
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Returns the current contents of the Dbg Trace String.
'
Function DbgTraceStr
	DbgTraceStr = Misc_Inc_dbgTraceStr
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' A wrapper around trace to make it easy to turn off by either changing
' this function or Commenting out all calls to DbgTrace
' Use DbgTrace to report general information that would not be used
' in a production environment.
'
Sub DbgTrace (msg)
	If Misc_Inc_dbgTraceEnabled Then
		Trace msg
	End If
	If Misc_Inc_DbgTraceToStrEnabled Then
		Misc_Inc_dbgTraceStr = Misc_Inc_dbgTraceStr &msg&VbCrLf
	End If
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Another wrapper around trace - this trace should be called to reflect
' error conditions - Unlike DbgTrace above, It should never be disabled.
'
Sub FaultTrace (msg)
	Trace msg
	If Misc_Inc_DbgTraceToStrEnabled Then
		Misc_Inc_dbgTraceStr = Misc_Inc_dbgTraceStr &msg&VbCrLf
	End If
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' URLEncoded strings. Lifted straight out of Professional ASP 2.0
' Copied from the WROX Active Server Pages book pages 87,88
' Gives back a string originally encoded with Server.URLEncode ()
' method.
'
Function URLDecode (Str)
	Dim strIn, strOut
	Dim strLeft, strRight
	Dim intPos, intLoop

	strIn=Str
	strOut=""
	intPos=InStr (strIn, "+")
	Do While intPos
		strLeft=""
		strRight=""
		If intPos > 1 Then
			strLeft=Left(strIn, intPos - 1)
		End If
		If intPos < Len(strIn) Then
			strRight=Mid(strIn, intPos + 1)
		End If
		strIn=strLeft&" "&strRight
		intPos=InStr(strIn, "+")
		intLoop=intLoop+1
	Loop
	intPos=InStr(strIn, "%")
	Do While intPos
		If intPos > 1 Then
			strOut=strOut&Left(strIn, intPos-1)
		End If
		strOut=strOut&Chr(CInt("&H" & Mid(strIn, intPos+1, 2)))
		If intPos > (Len(strIn)-3) Then
			strIn=""
		Else
			strIn=Mid(strIn, intPos+3)
		End If
		intPos=InStr(strIn, "%")
	Loop
	URLDecode=strOut&strIn
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'takes an id of the form '1' and turns it into 'SAMPL00000001'
'
Function normalizeID (id)
	On Error Resume Next
	Dim tmpval
	tmpval = Trim(id)
	If IsNumeric(tmpval) Then
		normalizeID = Session("DatabaseName")&_
					 String(8-Len(tmpval), "0")&tmpval
	Else
		normalizeID = tmpval
	End If
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This URLEncode is necessary because Server.URLEncode doesn't do
' spaces properly when a string is URLEncoded multiple times.
'
Function URLEncode (Str)
	Dim retval, ix, char
	For ix=1 To Len(Str)
		char=Asc(Mid(Str, ix, 1))
		If char>47 And char < 123 Then
			If ( char > 57 And char < 65 ) Or _
			   ( char > 90 And char < 97 ) Then
				retval = retval & "%" & Hex(char)
			Else
				retval = retval & Mid(Str, ix, 1)
			End If
		Else
			If char < 16 Then
				retval = retval & "%0" & Hex(char)
			Else
				retval = retval & "%" & Hex(char)
			End If
		End If
	Next
	URLEncode=retval
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Tells us if the object passed is really a valid object or not - The
' whole reason for this is so we can keep from tromping over any error
' info by using Set to apply an Empty value to a variant.  i.e. functions
' can return Nothing instead of Empty. so that
'   Set var = funcreturn
' will not generate an error.
'
Function IsValidObject (obj)
    IsvalidObject = False
    If IsObject (obj) Then
        If Not obj Is Nothing Then
            IsValidObject=True
        End If
    End If
End Function



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Lets us pass in an entitydef name that is not capitalized properly
' and still be happy.
'
Function ValidEntityDefName (Name)
	On Error Resume Next
	ValidEntityDefName = ""
	Dim entnames, ix
	entnames = Session("CoreConnection").GetQueryEntityDefNames
	For ix=LBound(entnames) To UBound(entnames)
		If UCase(Name) = UCase(entnames(ix)) Then
			ValidEntityDefName = entnames(ix)
			Exit Function
		End If
	Next
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' A simple wrapper around Session.Getentity - Returns
'
Function GetEntity (entname, dispname)
	On Error Resume Next
	Dim entity
	Set GetEntity = Nothing
	DbgTrace "Getentity Entry "&entname&" "&dispname
	Set entity = Session("CoreConnection").GetEntity (entname, dispname)
	If CheckError Then
		FaultTrace "GetEntity Fail "&CHR(34)&entname&CHR(34)&" "&_
				   CHR(34)&dispname&CHR(34)&" "&Err.Description
		Err.Source = "GetEntity "&Err.Source
		Exit Function
	End If
	Set GetEntity = entity
	DbgTrace "GetEntity Apparently Successful "&entity.GetEntityDefName&_
			 " "&entity.GetDisplayName
End Function


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' A simple wrapper around Session.GetentityByDbId
'
Function GetEntityByDbId (entname, dbid)
	On Error Resume Next
	Dim entity
	Set GetEntityByDbId = Nothing
	DbgTrace "GetentityByDbID "&entname&" "&dbid
	Set entity = Session("CoreConnection")._
		GetEntityByDbId (entname, dbid)
	If CheckError Then
		FaultTrace "GetEntityByDbId Fail "&CHR(34)&entname&CHR(34)&" "&_
				   CHR(34)&dbid&CHR(34)&" "&Err.Description
		Err.Source = "GetEntity "&Err.Source
		Exit Function
	End If
	Set GetEntityByDbId = entity
	DbgTrace "GetEntityByDbId Returning "&entity.GetEntityDefName&_
			 " "&entity.GetDisplayName

End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Make getting field values a little easier.
'
Function GetFieldValue (entity, fieldname)
	On Error Resume Next
	Dim fi
	GetFieldValue = Empty

	DbgTrace "GetFieldvalue "&entity.GetEntityDefName &" ("&fieldname&")"
	If Not IsValidObject (entity) Then
		Exit Function
	End If
	Set fi = entity.GetFieldvalue (fieldname)
	If CheckError Then
		FaultTrace "GetFieldValue Couldn't get FieldInfo object for "&_
				   fieldname
		Err.Source = "GetFieldValue "&Err.Source
		Exit Function
	End If
	If Not IsValidObject (fi) Then
		FaultTrace "GetFieldvalue entity.GetFieldValue didn't return an object"
		Err.Raise ERROR_NO_DATA,"GetFieldvalue",_
		   "entity.GetFieldValue didn't return an object"
		   
		Exit Function
	End If
	GetFieldValue = fi.GetValue
	DbgTrace "GetFieldValue Apparently Successful "&GetFieldValue
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' We wrap the calls to Entity.SetFieldValue so that we can report
' errors consistently.
'
Function SetFieldValue (entity, fieldname, value, source)
	On Error Resume Next
	Dim status

	SetFieldValue = False
	DbgTrace "SetFieldValue Entry "&entity.GetEntityDefName &" "&_
		  fieldname &" "&value
	status = entity.SetFieldValue (fieldname, value)
	If CheckError Then
		FaultTrace "Problems Setting Field Value "&fieldname&" "&value
		Err.Source = "SetFieldValue "&Err.Source
		Exit Function
	End If
	If status <> "" Then
		FaultTrace "SetFieldvalue error status "&status
		Err.Raise ERROR_WRITE_FAULT, source, status
		Exit Function
	End If
	SetFieldValue = True
	DbgTrace "SetFieldValue "&fieldname&" Apparently Successful"
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Put the entity object into edit mode - if possible.
' return True if successfull or the entity is already in edit mode.
'
Function Entity_BeginEdit (entity, action)
	On Error Resume Next
	Entity_BeginEdit = False

	DbgTrace "Entity_BeginEdit Entry"
	If Not IsValidObject (entity) Then
		Err.Raise ERROR_INVALID_DATA, "Entity_BeginEdit",_
		   "Invalid Entity Object"
		Exit Function
	End If

	If entity.isEditable = True Then
		DbgTrace "Entity_BeginEdit entity is already editable "&_
			  entity.GetEntityDefName
		Entity_BeginEdit = True
		Exit Function
	End If
	
	Call Session("CoreConnection").EditEntity(entity, action)
	If CheckError () Then
		FaultTrace "Entity_BeginEdit fail "&entity.GetEntityDefName&_
				   " "&Err.Description
		Err.Source = "Entity_BeginEdit "&Err.Source
		Exit Function
	End If
	Entity_BeginEdit = True
	DbgTrace "Entity_BeginEdit Apparently Successful "&entity.GetEntityDefName
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Attempt to validate the entity - if the validation fails, the reason
' will be in the Err.Description string.
'
Function Entity_Validate (entity)
	On Error Resume Next
	Dim status
	Entity_Validate = False
	DbgTrace "Entity_Validate Entry"
	If Not IsValidObject (entity) Then
		Err.Raise ERROR_INVALID_DATA, "Entity_Validate",_
		   "Invalid Entity Object"
		FaultTrace Err.Source&" "&Err.Description
		Exit Function
	End If
	status = entity.Validate
	If CheckError Then
		FaultTrace "Entity_Validate error "&Err.Description
		Err.Source = "Entity_Validate "&Err.Source
		Exit Function
	End If
	If status <> "" Then
		FaultTrace "Entity_Validate error "&status&vbCrLf
		Err.Raise ERROR_INVALID_DATA, "Entity_Validate", status
		Exit function
	End If
	Entity_Validate = True
	DbgTrace "Entity_Validate Apparently Successful "&entity.GetEntityDefName
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Attempt to commit changes to the entity - if the operation fails
' the status will be placed in the Err.Description string.
'
Function Entity_Commit (entity)
	On Error Resume Next
	Dim status
	Entity_Commit = False
	DbgTrace "Entity_Commit Entry"
	If Not IsValidObject (entity) Then
		Err.Raise ERROR_INVALID_DATA, "Entity_Commit", "Invalid Entity Object"
		FaultTrace Err.Source&" "&Err.Description
		Exit Function
	End If

	status = entity.Commit
	If CheckError Then
		FaultTrace "Entity_Commit error "&Err.Description
		Err.Source = "Entity_Commit "&Err.Source
		Exit Function
	End If
	If status <> "" Then
		FaultTrace "Entity_Commit error "&status&vbCrLf
		Err.Raise ERROR_INVALID_DATA, "Entity_Commit", status
		Exit function
	End If
	Entity_Commit = True
	DbgTrace "Entity_Commit Apparently Successful "&entity.GetEntityDefName
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Just a wrapper around Entity.Revert ... the only reason for returning
' False is if the entity is not an object. In any case we preserve the
' contents of the Err object through our call
'
Function Entity_AbortEdit (entity)
	Entity_AbortEdit = False
	Dim esrc, edesc, eno
	esrc = Err.Source
	edesc = Err.Description
	eno   = Err.No
	
	DbgTrace "Entity_AbortEdit "
	If Not IsValidObject (entity) Then
		Exit Function
	End If
	On Error Resume Next
	entity.Revert
	Err.Raise eno, esrc, edesc
	Entity_AbortEdit = True
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Trys to set the value and operation for the FieldFilter Node - Returns
' True if successful - False otherwise.
'
Function SetFilterNodeValue(qdef, fieldname, value, op)
    dim i,fnode, filters

    SetFilterNodeValue = False
	Set filters = qdef.queryfilter.fieldfilters

    For i=0 to filters.count-1
        Set fnode=filters.item(i)
        if fnode.fieldpath=fieldname Then
			fnode.Values = value
			fnode.CompOp = op
			SetFilterNodeValue = True
            Exit Function
        end if
    Next
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This guy translates accelerator characters to underscored labels.
'
Function XlateAccel (label)
	On Error Resume Next
	Dim ix
	ix = InStr (label, "&")
	If ix > 0 Then
		'DbgTrace "XlateAcel fixing up "&label&" ix = "&ix
		XlateAccel = mid(label, 1, ix-1)&"<u>"&Mid(label,ix+1,1)&_
				   "</u>"&Mid(label, ix+2, Len(label)-(ix+1))
		DbgTrace "XlateAcel fixed up "&Chr(34)&xlateAccel&Chr(34)
	Else
		XlateAccel = label
	End If
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Wraps the Entity.GetMaxFieldWidth with a little bit of diagnostic
' help
'
Function GetMaxFieldWidth (Entity, FieldName, DefaultWidth)
	On Error Resume Next

	If DefaultWidth <> "" Then
		GetMaxFieldWidth = CInt(DefaultWidth)
	Else
		GetMaxFieldWidth = 50
	End If
	
	Dim retval
	retval = Entity.GetFieldMaxLength(FieldName)
	If CheckError Then
		FaultTrace "GetMaxFieldLength: Problems "&Err.Source&_
				   " "&Err.Description
		Exit Function
	End If
	If CInt(retval) < 1 Then
		DbgTrace "GetMaxFieldWidth returning Default Width "&_
				 GetmaxFieldWidth
		Exit Function
	End If
	GetMaxFieldWidth = retval
	DbgTrace "GetMaxFieldWidth returning "&GetMaxFieldWidth
End Function



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Wrap getting the EntityDef name associated with a Reference Field
'
Function GetRefFieldEdefName (Entity, Fieldname)
	On Error Resume Next
	Dim edef
	GetRefFieldEDefName = ""
	Set edef = Session("CoreConnection").GetEntityDef(Entity.GetEntityDefName)
	If CheckError Then
		FaultTrace "GetRefFieldEdefName GetEntityDef Failure"
		Err.Source = "GetRefFieldEdefName "&Err.Source
		Exit Function
	End If
	
	GetRefFieldEdefName = edef.GetFieldReferenceEntitydef(FieldName).GetName
	If CheckError Then
		FaultTrace "GetRefFieldEdefname GetFieldReferenceEntityDef Fail"
		Err.Source = "GetRefFieldEdefName "&Err.Source
	End If
End Function



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This was previously defined in attachments/attachments_content.asp
' but it has been generalized and made into a common routine.
' We use this method to redirect the page because Explorer has
' problems with a response redirect that loads another page (even in the
' same window) if the page to render is a doc or excel file.
' -jb
'
Sub RedirectToURL (URL, ReturnPage)
	On Error Resume Next
	
	Trace "RedirectToURL redirecting to "+CHR(34)+URL+CHR(34)

	If InStr(Request.ServerVariables("HTTP_USER_AGENT"), _
			 "MSIE 3.03; Windows 3.1") > 1 Then
		Trace "Doing an ie3.03 redirection"
		Response.Redirect URL
	End If

	If ReturnPage <> "" Then
		Response.Write "<html><body><script language=JavaScript>"+_
				"function loadhandler() {window.open ("&_
				CHR(34)&URL&CHR(34)&"); "&_
				"window.parent.tm_content"+Session("SessionID")+".location.href="&CHR(34)&_
				ReturnPage&CHR(34)&"}"&"loadhandler();</script></body></html>"
		Response.Flush
		Response.End
		Exit Sub
	End If

	If InStr(Request.ServerVariables("HTTP_USER_AGENT"), "MSIE") > 1 Then
		Trace "doing an ie redirection"
		'
		' We're sending to IE 3.02 or 4.x - send a page with a small
		' script that handles the redirection
		'
		Response.Expires=0
		Response.Write "<html><body><script language=JavaScript>function "&_
				"loadhandler() { window.open ("&CHR(34)&URL&CHR(34)&"); "&_
				"window.history.back(); }loadhandler();</script>"				
		Response.Write "</body></html>"
		Response.Flush
		Response.End
		Exit Sub
	Else
		'
		' For NetScape all we gotta do is redirect to the _blank window
		' target ...
		'
		Trace "doing a NetScape redirection"
		Response.AddHeader "Window-target", "_blank"
		Response.Redirect URL
	End If
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' We use this to force getting a variable from the Form or Querystring
' collection and ignore any cookie value of the same name. We try the
' form first.
'
Function RequestVar(Name)
	If Not IsEmpty(Request.Form(Name)) Then
		RequestVar = Request.Form(Name)
		Exit Function
	End If
	If Not IsEmpty(Request.QueryString(Name)) Then
		RequestVar = Request.QueryString(Name)
		Exit Function
	End If
	RequestVar = Empty
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' we're passed a FormPage Object - we look and see if access is allowed
' on it - if not we see if it has any usergroups associated with it.
' if so we see if the user is a member of any of those groups
'
Function FormPageAccessAllowed (FormPage)
	On Error Resume Next
	FormPageAccessAllowed = False
	If Not IsValidObject(FormPage) Then
		FaultTrace "FormPageAccessAllowed: Passed in FormPage Not an Obect"
		Exit Function
	End If
	If FormPage.IsOkForAllUserGroups Then
		DbgTrace "FormPageAccessAllowed: Page.IsOkFormAllUserGroups = True "&_
				 " Access OK"
		FormPageAccessAllowed = True
		Exit Function
	End If

	If Not IsValidObject(Session("UserGroups")) Then
		FaultTrace "FormPageAccessAllowed: no UserGroups Dictionary"
		Exit Function
	End If
	Dim usergroup, usergroups
	
	FormPage.GetUserGroups usergroups
	If CheckError Then
		FaultTrace "FormPageAccessAllowed: Couldn't Get Page UserGroups "&_
				   "ERROR: "&Err.Description
		Err.Clear
		Exit Function
	End If
	For Each usergroup In usergroups
		If Session("UserGroups").Exists(UCase(usergroup)) Then
			FormPageAccessAllowed = True
			DbgTrace "FormPageAccessAllowed: Found UserGroup "&usergroup&_
					 " Access OK"
			Exit Function
		End If
	Next
End Function

%>

<script language=JScript runat=server>
//------------------------------------------------------------------//
//
// Function:  getItem
// Author:    jb
//
// returns the ith element of the array
//
function JSSortedArray_getItem(ix)
{
	var undefval;
	if (ix >= 0 && ix < this.ary.length) {
		return this.ary[ix];
	} else {
		var undefval;
		return undefval;
	}
}



//------------------------------------------------------------------//
//
// Function:  JSSortedArray
// Author:    jb
//
// The JSSortedArray Object Creator
//
function JSSortedArray(ary)
{
	this.ary = new Array();
	var ix;
	for(ix=ary.lbound(1); ix <= ary.ubound(1); ++ix) {
		this.ary[this.ary.length] = ary.getItem(ix);
	} 
	this.ary.sort();
	this.getItem = JSSortedArray_getItem;
	this.count = this.ary.length-1;
}




//------------------------------------------------------------------//
//
// Function:  CreateJSSortedArray
// Author:    jb
//
// Sort of our JSSortedArray - ClassFactory
//
function CreateJSSortedArray (ary)
{
 	var retval = new JSSortedArray (ary);
	return retval;
}
</script>
<%

Sub dumparray(Name, ary)
	On Error Resume Next
	Dim ix
	Trace "Dump of Array "&Name
	Trace " LBound = "&LBound(ary)
	Trace " UBound = "&UBound(ary)
	For ix=LBound(ary) To UBound(ary)
		Trace " "&Name&"("&ix&") = "&ary(ix)
	Next
End Sub




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function SortStringArray(ary)
	On Error Resume Next
	SortStringArray = ary
	If Not IsArray(ary) Then
		DbgTrace "SortStringArray Not An Array "&TypeName(ary)
		Exit Function
	End If
	If UBound(ary) < LBound(ary) Then
		DbgTrace "SortStringArray Empty Array nothing to sort"
		Exit Function
	End If
	Dim ix, retval(), sortedarray
	If CInt(Session("DbgTraceLevel")) > 1000 Then
		dumparray "ArrayPreSort", ary
	End If
	Set sortedarray = CreateJSSortedArray(ary)
	If CheckError Then
		FaultTrace "SortStringArray Problems Creating SortedArray Object"&_
				   " Error: "&Err.Description&" Source: "&Srr.Source
		Err.Clear
		Exit Function
	End If
	ReDim retval(sortedarray.count)
	For ix=0 To sortedarray.count
		retval(ix) = sortedarray.getItem(ix)
	Next
	If CheckError Then
		FaultTrace "SortStringArray Problems Sorting Array"&_
				   " Error: "&Err.Description&" Source: "&Srr.Source
		Err.Clear
		Exit Function
	End If
	If CInt(Session("DbgTraceLevel")) > 1000 Then
		dumparray "ArrayPostSort", retval
	End If
	SortStringArray = retval
End Function



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return a string suitable for placing inside a <font> tag that specifies
' font color and face attributes (if they are set)
'
Function GlobalFontAttributes
	On Error Resume Next
	Dim retval
	retval = ""
	If Not IsEmpty(BODY_TEXT_FONT_COLOR) And _
		BODY_TEXT_FONT_COLOR <> "" Then
		retval = " color="&CHR(34)&BODY_TEXT_FONT_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_TEXT_FONT_FACE) And _
		BODY_TEXT_FONT_FACE <> "" Then
		retval = retval &" face="&CHR(34)&BODY_TEXT_FONT_FACE&CHR(34)
	End If
	GlobalFontAttributes=retval
End Function


Function GlobalMenuTitleFontAttributes
	On Error Resume Next
	Dim retval
	retval = ""
	If Not IsEmpty(MENU_TITLE_FONT_COLOR) And _
		MENU_TITLE_FONT_COLOR <> "" Then
		retval = " color="&CHR(34)&MENU_TITLE_FONT_COLOR&CHR(34)
	End If
	If Not IsEmpty(MENU_TITLE_FONT_FACE) And _
		MENU_TITLE_FONT_FACE <> "" Then
		retval = retval &" face="&CHR(34)&MENU_TITLE_FONT_FACE&CHR(34)
	End If
	GlobalMenuTitleFontAttributes=retval
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
Function GlobalBodyAttributes
	On Error Resume Next
	Dim retval
	retval = ""
	If Not IsEmpty(BODY_TEXT_COLOR) And _
	   BODY_TEXT_COLOR <> "" Then
		retval = " text="&CHR(34)&BODY_TEXT_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_ALNK_COLOR) And _
		BODY_ALNK_COLOR <> "" Then
		retval = retval & " link="&CHR(34)&BODY_ALNK_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_LNK_COLOR) And _
	   BODY_LNK_COLOR <> "" Then
		retval = retval &" vlink="&CHR(34)&BODY_LNK_COLOR&CHR(34)
	End If
	GlobalBodyAttributes=retval
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' We'll add the variable and value passed to us to a specific browser
' cookie that lasts 21 days (like a habit)
'
Function AddUserSetting(Name, value)
	On Error Resume Next
	If Name <> "" Then
		Response.Cookies("CQWebUsrSettings")(Name) = URLEncode(CStr(value))
		Response.Cookies("CQWebUsrSettings").Expires = Date+21
		AddUserSetting = True
	Else
		AddUserSetting = False
	End if
End Function




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' If our cookie contains the Variable requested - we return it,
' otherwise Empty
'
Function GetUserSetting(Name)
	On Error Resume Next
	GetUserSetting = empty
	If Request.Cookies("CQWebUsrSettings").HasKeys Then
		If Not IsEmpty(Request.Cookies("CQWebUsrSettings")(Name)) Then
			GetUserSetting = _
				URLDecode(Request.Cookies("CQWebUsrSettings")(Name))
		End If
	End If
End Function

%>
<script language=jscript runat=server>
//------------------------------------------------------------------//
//
// Function:  BrowserInfoObj
// Author:    jb
//
// We use the regular expression capabilities of JavaScript to
// parse the HTTP_USER_AGENT string to determine browser type
// information and encapsulate it in a javaScript Object that
// is more readily accessable from VBScript.
//
// Some of the Strings we already encounter are ...
//  Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)
//  Mozilla/3.01 Gold (X11;I;SunOS 5.5.1 sun4u)
//  Mozilla/4.04 [en] (X11;I;SunOS 5.5.1 sun4u)
//  Mozilla/3.04 (WinNT; U)
//  Mozilla/4.04 [en] (WinNT; U ;Nav)
//  Mozilla/4.5b2 [en] (WinNT; I)
//
function BrowserInfoObj()
{
	var tstr = new String (Request.ServerVariables("HTTP_USER_AGENT"));
	var result;
	this.is16Bit = false;
	if (tstr.search(/msie/i) > 0) {
		this.BType = "MSIE";
		this.isMSIE = true;
		this.isNetscape = false;
		result = tstr.match(/.*msie (\d+)\.(\d+).*; ([^)]+)/i);
		if (result != null) {
			this.majorVersion = result[1];
			this.minorVersion = result[2];
			this.os = result[3];
		} else {
			this.majorVersion = 3;
			this.minorVersion = 0;
			this.os = "unknown";
		}
	} else {
		this.BType = "NetScape";
		this.isMSIE = false;
		this.isNetscape = true;
		result = tstr.match(/.*mozilla\/(\d+)\.(\d+).*\((\w+)/i);
		if (result != null) {
			this.majorVersion = result[1];
			this.minorVersion = result[2];
			this.os = result[3];
		} else {
			this.majorVersion = 3;
			this.minorVersion = 0;
			this.os = "unknown";
		}
	}
	if (this.os == "Windows 3.1") {
		this.is16Bit = true;
	}
}



//------------------------------------------------------------------//
//
// Function:  CreateBrowserInfoObj
// Author:    jb
//
// our BrowserInfoObj ClassFactory method.
//
function CreateBrowserInfoObj()
{
	return new BrowserInfoObj();
}
</script>
