<%
' Copyright 1998, 1999 Rational Software Corporation
'
'   File: work_area_html.inc
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added splash screen state.  
'							Added modification history.
'							Cleaned up code.
'	6/22/99		PSun		Added back state code for prompting script names.
'							Added error checking for MSXML.
'							Added code to set timeout properly.
'							Added code to check for parent window existance.
'	6/25/99		PSun		Cleaned up code formatting.
'	7/9/99		PSun		Added additional error checking for MSXML.
'	7/23/99		PSun		Changed top_title to tm_top_title.
'							Removed splash screen.
'	7/30/99		PSun		Changed default timeout interval.
'	8/16/99		PSun		Removed "AllPass" code.
'	8/18/99		PSun		Added SessionID to the window names.
'	8/25/99		PSun		Code cleanup.
'	11/30/99	PSun		Added SessionID to URL to handle timeout/logoff
'							cases.
'

WorkArea

Sub WorkArea
	' requires:
	' modifies:
	' effects:  This is the main loop of the program.  It evaluates which
	'			state session variables have been set and responds 
	'			accordingly dispatching to the right dialog.

	On Error Resume Next
	%>
	<script language='JavaScript'>
		var iScreenW = screen.width;
		var iScreenH = screen.height;
		var winChild;
		if (window.navigator.appName == 'Netscape') {
			iScreenW = window.outerWidth/2 + window.screenX - 50;
			iScreenH = window.outerHeight/2 + window.screenY - 50;
		}
			
	</script>
	<%
	Dim strUserID

	CheckUserInput
	%>	
	<center>
	<%

	' If we have not logged in yet, display the repository login dialog.
	If IsEmpty(Session("SubmitRepoInfo")) Then
		%>	
		<script language='JavaScript'>
			winChild = window.open('', 'PromptRepositoryInfo<%=Session("SessionID")%>',
								   'width=100,height=100,resizable=yes,left='
								   + iScreenW + ',top=' + iScreenH +
								   ',screenX=' + iScreenW + ',screenY=' + 
								   iScreenH);
			window.open('top_title.asp', 'tm_top_title<%=Session("SessionID")%>');
			self.focus();
			winChild.location.replace('prompt_repository_info.asp?SessionID=' + 
									  '<%=Session("SessionID")%>');
			top.winPrevious = winChild;
		</script>
		<%
	' If we have not selected a script, display the script name select dialog.
	ElseIf IsEmpty(Session("SubmitScriptName")) Or _
		   Request.QueryString("State") = "PromptScriptName" Then
		%>	
		<script language='JavaScript'>
			winChild = window.open('', 'tm_content<%=Session("SessionID")%>');
			self.focus();
			winChild.location.replace('prompt_testcase_name.asp?SessionID=' + 
									  '<%=Session("SessionID")%>');
			window.open('logoff_menu.asp', 'tm_side_menu<%=Session("SessionID")%>');
			top.winPrevious = winChild;
		</script>
		<%
		If CheckError Then
			ErrorDialog "Test Case Selection Error", "Select Another Test Case"
			Exit Sub
		End If
	' If we haven't submitted results, then display the script.
	ElseIf IsEmpty(Session("SubmitResult")) Then
		' Set the session timeout from the cookie or to the 120 minute default.
	    strUserID = Session("UserID")	
	    If Request.Cookies(strUserID)("Timeout") = Empty Then
			Session.Timeout = 120
		Else
			Session.Timeout = Request.Cookies(strUserID)("Timeout")
		End If
		' Load the data from file only if we haven't done it yet.
	    If Session("DataLoaded") = Empty Then
			LoadScript
			If CheckError Then
				If Err.Description = "ActiveX component can't create object" Or _
				   Err.Description = "006~ASP 0177~Server.CreateObject Failed~Invalid class string" Then
					Err.Description = "The server does not have the proper" +_
									  " xml parser installed.&nbsp;&nbsp;" +_
									  "Please contact your web server " +_
									  "administrator."
					ErrorDialog "Corrupt Script Error", "Logon Again"
				Else
					ErrorDialog "Corrupt Script Error", "Select Another Test Case"
				End If	
				Exit Sub
			Else
				Session("DataLoaded") = true
			End If
	    End If

		' Display the script
		DisplayScript
		If CheckError Then
			ErrorDialog "Script Display Error", "Select Another Test Case"
			Exit Sub
		End If
	' If we have not specified logging infomation yet, display the log info 
	' dialog.
	ElseIf IsEmpty(Session("SubmitLogInfo")) Then
		Session("InLogInfoState") = Empty
		%>	
		<script language='JavaScript'>
			winChild = window.open('', 'PromptLogInfo<%=Session("SessionID")%>',
								   'width=100,height=100,resizable=yes,left='
								   + iScreenW + ',top=' + iScreenH +
								   ',screenX=' + iScreenW + ',screenY=' + 
								   iScreenH);
			self.focus();
			winChild.location.replace('prompt_log_info.asp?SessionID=' + 
									  '<%=Session("SessionID")%>');
			top.winPrevious = winChild;
		</script>
		<%
	
		' Make sure we redraw the script in the background.	
	    DisplayScript
	    If CheckError Then
			ErrorDialog "Log Selection Error", "Select Another Log"
			Exit Sub
		End If
	' If we have not written the log yet, do so.	
	ElseIf IsEmpty(Session("WriteLog")) Then
		%>
		<script language='JavaScript'>
			winChild = window.open('', 'WriteLog<%=Session("SessionID")%>',
								   'width=100,height=100,resizable=yes,left='
								   + iScreenW + ',top=' + iScreenH +
								   ',screenX=' + iScreenW + ',screenY=' + 
								   iScreenH);
			self.focus();
			winChild.location.replace('write_log.asp?SessionID=' + 
									  '<%=Session("SessionID")%>');
			top.winPrevious = winChild;
		</script>
		<%
		If CheckError Then
			ErrorDialog "Log Write Error", "Select Another Log"
			Exit Sub
        End If
	' The log has been written but we are back to this loop because the
	' user hit back.
    Else
		%>
		<script language='JavaScript'>
			winChild = window.open('', 'WriteLog<%=Session("SessionID")%>',
								   'width=100,height=100,resizable=yes,left='
								   + iScreenW + ',top=' + iScreenH +
								   ',screenX=' + iScreenW + ',screenY=' + 
								   iScreenH);
			self.focus();
			winChild.location.replace('write_log.asp?SessionID=' + 
									  '<%=Session("SessionID")%>');
			top.winPrevious = winChild;
		</script>
		<%
		If CheckError Then
			ErrorDialog "Log Write Error", "Select Another Log"
			Exit Sub
        End If		
	End If
	%>
	</center>
	<%
End Sub
%>