<%@ language = VBScript %>
<%
' Copyright 1998, 1999, 2000 Rational Software Corporation
'
'	File: default.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added window tracking variables.  
'							Added modification history.
'							Added "Alive" session variable for timeout checking.
'							Added window names.
'	6/22/99		PSun		Added child window tracking for options, notes, ResultDetails,
'								and most prompt dialogs.
'							Added back state code for prompting script names.
'	6/24/99		PSun		Added child window tracking for error dialogs.
'	7/23/99		PSun		Removed frame dependence session variables.
'							Renamed frames.
'	7/29/99		PSun		Added footer frame.  Changed frame sizes.
'	8/12/99		PSun		Added browser checking and browser version checking.
'	8/18/99		PSun		Added SessionID to window and frame names.
'	8/20/99		PSun		Chnaged browser checking content.
'	8/25/99		PSun		Code cleanup.
'	7/10/00		PSun		Fixed copyright.
'	3/1/01		PSun		Added code for selecting test cases.
'	7/11/02         OMoroz		Changed "Comment" column name to " Result Details" 
'       08/19/02	OMoroz          Added code to support Natscape 6.2.2
'
%>
<!--#include file="./utilities/misc.inc"-->
<!--#include file="./utilities/error.inc"-->
<%
	DisplayOutput

	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the toplevel page.

		' Check for a browser that is Version 4 or greater of MSIE or Netscape 
		If (BrowserIsMSIE() Or BrowserIsNetscape()) = false Or _
		   CInt(GetBrowserMajorVersion) < 4 Then
				%>
				<html>
				<head>			
					<title>
						Rational TestManager - Manual Script Execution
					</title>
				</head>
				<body bgcolor='#ffffff'>
					Browser not supported.
					<br>
					Please see documentation for supported browsers.
				</body>
				</html>
				<%
		Else
			' Generate a unique session id for all the windows.			
			If Session("Alive") <> true Then
				Session("SessionID") = CStr(Year(Date)) + _
									   CStr(Month(Date)) + _
									   CStr(Day(Date)) + _
									   CStr(Hour(Time)) + _
									   CStr(Minute(Time)) + _
									   CStr(Second(Time))
			End If

			Session("Alive") = true
						
			' A hack to get back state somewhat working.
			Dim strState
			If Request.QueryString("State") = "PromptScriptName" Then
				strState = "?State=PromptScriptName"
			Session("Type") = Request.QueryString("Type")
			Session("Expand") = Request.QueryString("Expand")
			Session("Collapse") = Request.QueryString("Collapse")
			Session("ScriptName") = Request.QueryString("ManualScriptName")
			Session("TestCaseName") = Request.QueryString("TestCaseName")
			Session("TestCaseUID") = Request.QueryString("TestCaseUID")
		
				
			End If
			
			%>
			
			<html>
			<head>
				<title>Rational ManualTest Web Execution</title>
				<meta http-equiv='keywords' content='TestManager'>
				<meta http-equiv='description' content='TestManager'>
				<meta http-equiv='Pragma' content='no-cache'>
				<meta http-equiv='Expires' content='-1'>
				<script language='JavaScript'>					
					window.name = "TestManager<%=Session("SessionID")%>"
																				
					var winPrevious;
					var winOptions;
					var winNote;
					var winResultDetails;


					var winError;
											
					function CloseChildren() {
						if (winError != null) {
							if (!winError.closed) {
								winError.close();
							}
						}
                                              

						if (winPrevious != null  )  {
							if (!(window.navigator.appName == 'Netscape' &&  window.navigator.appVersion.substring(1,0) < "6")) {
							

								if (!winPrevious.closed) {
									winPrevious.close();
								}
							}

							
						}


						
						if (winOptions != null) {
							if (!winOptions.closed) {
								winOptions.close();
							}
						}
						if (winResultDetails != null) {
							if (!winResultDetails.closed) {
								winResultDetails.close();
							}
						}
						if (winNote != null) {
							if (!winNote.closed) {
								winNote.close();
							}
						}
						return;
					}
				</script>
			</head>
			<!-- frames -->

			<frameset rows='70,*,50' frameborder='0' framespacing='0' border='0'>
				<noframes>Sorry, you need frames to run this application.</noframes>
			    <frame name='tm_top_title<%=Session("SessionID")%>' src='top_title.asp<%=strState%>' scrolling='no' frameborder='0' noresize>
				<frameset cols='120,*' border='0' onUnload='CloseChildren();'>
				    <frame name='tm_side_menu<%=Session("SessionID")%>' src='blank_menu.asp' scrolling='no' frameborder='0'>
			    	<frame name='tm_content<%=Session("SessionID")%>' src='default_content.asp<%=strState%>' frameborder='0'>
				</frameset>
				<frame name='tm_footer_menu<%=Session("SessionID")%>' src='blank_menu.asp' scrolling='no' frameborder='0'>
			</frameset>
			</html>
			<%
		End If
	End Sub
%>
