<%@ language = VBScript %>
<% Option Explicit %>
<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: default_content.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added support for splash screen.  
'							Added modification history.
'	6/22/99		PSun		Changed content to tm_content.
'							Added back state code for prompting script names.
'	7/23/99		PSun		Moved dependence on ClearQuest html macros.
'							Removed splash screen code.
'	7/29/99		PSun		Added changes to support side and footer menus.
'	7/30/99		PSun		Added timeout.
'	8/18/99		PSun		Added SessionID to window and frame names.
'	8/23/99		PSun		Changed text case in the "State" compare.
'	8/25/99		PSun		Code cleanup.
'	11/30/99	PSun		Added default menus.
'
%>

<!--#include file="./utilities/all.inc"-->
<!--#include file="preamble.inc"-->

<%
	Dim strState
	Dim strSideMenu
	Dim strFooterMenu
	CheckUserInput
	InitializeState
	
	Sub InitializeState
		' requires:
		' modifies: strState, strSideMenu, strFooterMenu.
		' effects:  Sets the state and menus.
	
		On Error Resume Next
	
		If IsEmpty(Session("SubmitRepoInfo")) Then
			strState = "logon"
			strSideMenu = "blank_menu"
			strFooterMenu = "blank_menu"
		ElseIf IsEmpty(Session("SubmitScriptName")) Or _
			Request.QueryString("State") = "PromptScriptName" Then
			strState = "script_select"
			strSideMenu = "logoff_menu"
			strFooterMenu = "blank_menu"
		ElseIf IsEmpty(Session("SubmitResult")) Then
			strState = "script_display"
			strSideMenu = "file_menu"
			strFooterMenu = "script_menu"
		ElseIf IsEmpty(Session("SubmitLogInfo")) Then
			strState = "script_display"
			strSideMenu = "file_menu"
			strFooterMenu = "script_menu"
		ElseIf IsEmpty(Session("WriteLog")) Then
			strState = "write_log"
			strSideMenu = "blank_menu"
			strFootermenu = "blank_menu"
		Else
			strSideMenu = "blank_menu"
			strFooterMenu = "blank_menu"
		End If
	End Sub
	
	%>
	<html>
	<head>
		<title>
			Rational TestManager - Manual Script Execution
		</title>
		<script language='JavaScript'>
			function set_menu()
			{
				if (window             &&
					window.parent      &&
					window.parent.tm_side_menu<%=Session("SessionID")%>    ) {
					window.parent.tm_side_menu<%=Session("SessionID")%>.location.href="./<%=strSideMenu%>.asp";
				}

				if (window             &&
					window.parent      &&
					window.parent.tm_footer_menu<%=Session("SessionID")%>    ) {
					window.parent.tm_footer_menu<%=Session("SessionID")%>.location.href="./<%=strFooterMenu%>.asp";
				}
			}

			function help_func() 
			{
				 window.open("./help/help.asp?HelpLink=<%=strState%>","TestManagerHelp");
			}
		</script>
	</head>
	<body bgcolor='#ffffff' onload='set_menu();'>
		<style type='text/css'>
			td {font-family: Arial; font-size: 10pt} 
		</style>
	<!--#include file="work_area_html.inc"-->
	</body>
	</html>
