<%
' Copyright 1998, 1999, 2000 Rational Software Corporation
'
'	File: top_title.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification Hhistory.
'	6/22/99		PSun		Changed project/script check.
'							Added back state code for prompting script names.
'	7/15/99		PSun		Added Rational to title.
'	7/29/99		PSun		Changed target of help link.
'	8/25/99		PSun		Partial code cleanup.
'	7/12/00		PSun		Fixed dialog to use ML data store.
'	12/15/00	PSun		Changed colors scheme and logo.
'
%>
<!--#include file="./utilities/globalvars.inc" -->
<%
if not IsEmpty(HelpLink)  then
	HelpLink = "?HelpLink=" + HelpLink
end if

if IsEmpty(PromptString) then
	PromptString = " &nbsp; "
end If

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Return a string suitable for placing inside a <font> tag that specifies
' font color and face attributes (if they are set)
'
Function TitleFontAttributes
	On Error Resume Next
	Dim retval
	retval = ""
	If Not IsEmpty(TITLE_TEXT_FONT_COLOR) And _
		TITLE_TEXT_FONT_COLOR <> "" Then
		retval = " color="&CHR(34)&TITLE_TEXT_FONT_COLOR&CHR(34)
	End If
	If Not IsEmpty(TITLE_TEXT_FONT_FACE) And _
		TITLE_TEXT_FONT_FACE <> "" Then
		retval = retval &" face="&CHR(34)&TITLE_TEXT_FONT_FACE&CHR(34)
	End If
	TitleFontAttributes=retval
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Duplication of GlobalBodyAttributes in misc.inc - however we don't
' include that and this way if we need special Title stuff - here it is.
Function TitleBodyAttributes
	On Error Resume Next
	Dim retval
	retval = ""
	If Not IsEmpty(BODY_BK_COLOR) And _
	   BODY_BK_COLOR <> "" Then
		retval = " bgcolor="&CHR(34)&BODY_BK_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_TEXT_COLOR) And _
	   BODY_TEXT_COLOR <> "" Then
		retval = retval & " text="&CHR(34)&BODY_TEXT_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_ALNK_COLOR) And _
		BODY_ALNK_COLOR <> "" Then
		retval = retval & " link="&CHR(34)&BODY_ALNK_COLOR&CHR(34)
	End If
	If Not IsEmpty(BODY_LNK_COLOR) And _
	   BODY_LNK_COLOR <> "" Then
		retval = retval &" vlink="&CHR(34)&BODY_LNK_COLOR&CHR(34)
	End If
	TitleBodyAttributes=retval
End Function

%>
<html>
<head>
<%
' The following HTML serves the purpose of inhibiting enter key press
' events from bubbling up out of tables when we don't want them
' -jb
If InStr (Request.ServerVariables ("HTTP_USER_AGENT"), "MSIE 4") > 0 Then
	%>
<script language='javascript'>
<!--
	function CatchKey() {
		if (window.event.srcElement.type=="text" &&
			window.event.keyCode==13				) {
			window.event.returnValue = 0;
		}
	}
-->
</script>
</head>
<body <%=TitleBodyAttributes%> onkeypress='CatchKey()'>
<%
Else
%>
</head>
<body <%=TitleBodyAttributes%>>
<%
End If
'do not update this frame again this session
session("Title_Update")=Empty
%>
<font size='1'>
<table cellspacing=0 cellpadding=0 border=0 width="100%">
	<tr>
		<td bgcolor=black>&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td rowspan=2 align=center valign=top width=10%>
			<a href="http://www.rational.com" target="Rational">
			<img src="images/Logon_RationalLogo.gif" border=0>
			</a>
		</td>
		<td colspan=2 bgcolor=black align=center valign=middle nowrap>
			<a href="http://www.rational.com" target="Rational">
			<img src="images/Logon_RationalURL.gif" border=0>
			</a>
			<a href="http://www.rational.com/products/testmanager" target="_new">
			<img src="images/Logon_TestManager.gif" border=0>
			</a>
		</td>
		<td bgcolor=black align="right" valign=middle nowrap>
			<a	href="top_title.asp" target="top_title" onClick="getHelp();return false;">
			<img src="images/Logon_Help.gif" border=0></a>
			<a	href="top_title.asp" target="top_title" onClick="getAbout();return false;">
			<img src="images/Logon_About.gif" border=0></a>
		</td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<th colspan=2 align="center">
				<font<%=TitleFontAttributes%>>
				<%
				if not isEmpty(session("DBSetName")) then
					Response.Write Session ("DBSetName") & " Repository"
					if not isEmpty (session("coreconnection")) then
						Response.Write (":&nbsp;")
					end if
				end if
				
				Response.Write ("&nbsp;")

				if (not isEmpty(session("coreconnection"))) then
					Response.Write "Database " & session("DatabaseName")
				end if%>
				<%If Session("Project") <> "" Then%>[<%=Session("Project")%>] <%End If%><%If Session("TestCaseName") <> "" Then %>[<%=Session("TestCaseName")%>] <%End If%><%If Session("ScriptName") <> "" Then %>[<%=Session("ScriptName")%>]<%End If%>
				</font>
		</th>
	  </tr>
</table>
	<script language='JavaScript'>

		function getHelp() {
			window.open('./help/help.asp','TestManagerHelp');
		}
		
		function getAbout() {
			var iScreenW = screen.width;
			var iScreenH = screen.height;
			var winChild;
			if (window.navigator.appName == 'Netscape') {
				iScreenW = window.outerWidth/2 + window.screenX - 150;
				iScreenH = window.outerHeight/2 + window.screenY - 100;
			}

			window.open ('./about/default_content.asp','TestManagerAbout',
						'width=300,height=200,left='
						+ iScreenW + ',top=' + iScreenH +
						',screenX=' + iScreenW + ',screenY=' + iScreenH);
		}
	</script>
</font>
</body>
</html>
